Scala Standard Library2.13.5 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package util
  Definition Classes
    scala
-  package control
  Definition Classes
    util
-  package hashing
  Definition Classes
    util
-  package matching
  Definition Classes
    util
- ChainingOps
- ChainingSyntax
- DynamicVariable
- Either
- Failure
- Left
- Properties
- Random
- Right
- Sorting
- Success
- Try
- Using
- chaining

c

scala.util

# Success

###

#### final case class Success[+T](value: T) extends Try[T] with Product with Serializable

Source
  Try.scala

Linear Supertypes
Try[T], java.io.Serializable, Product, Equals, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Success
2. Try
3. Serializable
4. Product
5. Equals
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new Success(value: T)

### Type Members

1.  final class WithFilter extends AnyRef

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   We need a whole WithFilter class to honor the "doesn't create a new collection" contract even though it seems unlikely to matter much in a collection with max size 1.

   Definition Classes
     Try

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##: Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Success[T] toany2stringadd[Success[T]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (Success[T], B)
   Implicit
     This member is added by an implicit conversion from Success[T] toArrowAssoc[Success[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

8.  def collect[U](pf: PartialFunction[T, U]): Try[U]

   Applies the given partial function to the value from this `Success` or returns this if this is a `Failure`.

   Applies the given partial function to the value from this `Success` or returns this if this is a `Failure`.

   Definition Classes
     Success → Try
9.  def ensuring(cond: (Success[T]) => Boolean, msg: => Any): Success[T]
   Implicit
     This member is added by an implicit conversion from Success[T] toEnsuring[Success[T]] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (Success[T]) => Boolean): Success[T]
    Implicit
      This member is added by an implicit conversion from Success[T] toEnsuring[Success[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: => Any): Success[T]
    Implicit
      This member is added by an implicit conversion from Success[T] toEnsuring[Success[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): Success[T]
    Implicit
      This member is added by an implicit conversion from Success[T] toEnsuring[Success[T]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
14.  def failed: Try[Throwable]

    Inverts this `Try`.

    Inverts this `Try`. If this is a `Failure`, returns its exception wrapped in a `Success`. If this is a `Success`, returns a `Failure` containing an `UnsupportedOperationException`.

    Definition Classes
      Success → Try
15.  def filter(p: (T) => Boolean): Try[T]

    Converts this to a `Failure` if the predicate is not satisfied.

    Converts this to a `Failure` if the predicate is not satisfied.

    Definition Classes
      Success → Try
16.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

17.  def flatMap[U](f: (T) => Try[U]): Try[U]

    Returns the given function applied to the value from this `Success` or returns this if this is a `Failure`.

    Returns the given function applied to the value from this `Success` or returns this if this is a `Failure`.

    Definition Classes
      Success → Try
18.  def flatten[U](implicit ev: <:<[T, Try[U]]): Try[U]

    Transforms a nested `Try`, ie, a `Try` of type `Try[Try[T]]`, into an un-nested `Try`, ie, a `Try` of type `Try[T]`.

    Transforms a nested `Try`, ie, a `Try` of type `Try[Try[T]]`, into an un-nested `Try`, ie, a `Try` of type `Try[T]`.

    Definition Classes
      Success → Try
19.  def fold[U](fa: (Throwable) => U, fb: (T) => U): U

    Applies `fa` if this is a `Failure` or `fb` if this is a `Success`.

    Applies `fa` if this is a `Failure` or `fb` if this is a `Success`. If `fb` is initially applied and throws an exception, then `fa` is applied with this exception.

    fa

      the function to apply if this is a `Failure`

    fb

      the function to apply if this is a `Success`

    returns

      the results of applying the function

    Definition Classes
      Success → Try
    Example:

    1.     val result: Try[Int] = Try { string.toInt }
           log(result.fold(
             ex => "Operation failed with " + ex,
             v => "Operation produced value: " + v
           ))

20.  def foreach[U](f: (T) => U): Unit

    Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

    Applies the given function `f` if this is a `Success`, otherwise returns `Unit` if this is a `Failure`.

    Note: If `f` throws, then this method may throw an exception.

    Definition Classes
      Success → Try
21.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from Success[T] toStringFormat[Success[T]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  def get: T

    Returns the value from this `Success` or throws the exception if this is a `Failure`.

    Returns the value from this `Success` or throws the exception if this is a `Failure`.

    Definition Classes
      Success → Try
23.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
24.  def getOrElse[U >: T](default: => U): U

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Returns the value from this `Success` or the given `default` argument if this is a `Failure`.

    Note:: This will throw an exception if it is not a success and default throws an exception.

    Definition Classes
      Success → Try
25.  def isFailure: Boolean

    Returns `true` if the `Try` is a `Failure`, `false` otherwise.

    Returns `true` if the `Try` is a `Failure`, `false` otherwise.

    Definition Classes
      Success → Try
26.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
27.  def isSuccess: Boolean

    Returns `true` if the `Try` is a `Success`, `false` otherwise.

    Returns `true` if the `Try` is a `Success`, `false` otherwise.

    Definition Classes
      Success → Try
28.  def map[U](f: (T) => U): Try[U]

    Maps the given function to the value from this `Success` or returns this if this is a `Failure`.

    Maps the given function to the value from this `Success` or returns this if this is a `Failure`.

    Definition Classes
      Success → Try
29.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
30.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

31.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

32.  def orElse[U >: T](default: => Try[U]): Try[U]

    Returns this `Try` if it's a `Success` or the given `default` argument if this is a `Failure`.

    Returns this `Try` if it's a `Success` or the given `default` argument if this is a `Failure`.

    Definition Classes
      Success → Try
33.  def productElementNames: Iterator[String]

    An iterator over the names of all the elements of this product.

    An iterator over the names of all the elements of this product.

    Definition Classes
      Product
34.  def recover[U >: T](pf: PartialFunction[Throwable, U]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like map for the exception.

    Definition Classes
      Success → Try
35.  def recoverWith[U >: T](pf: PartialFunction[Throwable, Try[U]]): Try[U]

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`.

    Applies the given function `f` if this is a `Failure`, otherwise returns this if this is a `Success`. This is like `flatMap` for the exception.

    Definition Classes
      Success → Try
36.  final def synchronized[T0](arg0: => T0): T0

    Executes the code in `body` with an exclusive lock on `this`.

    Executes the code in `body` with an exclusive lock on `this`.

    returns

      the result of `body`

    Definition Classes
      AnyRef
37.  def toEither: Either[Throwable, T]

    Returns `Left` with `Throwable` if this is a `Failure`, otherwise returns `Right` with `Success` value.

    Returns `Left` with `Throwable` if this is a `Failure`, otherwise returns `Right` with `Success` value.

    Definition Classes
      Success → Try
38.  def toOption: Option[T]

    Returns `None` if this is a `Failure` or a `Some` containing the value if this is a `Success`.

    Returns `None` if this is a `Failure` or a `Some` containing the value if this is a `Success`.

    Definition Classes
      Success → Try
39.  def transform[U](s: (T) => Try[U], f: (Throwable) => Try[U]): Try[U]

    Completes this `Try` by applying the function `f` to this if this is of type `Failure`, or conversely, by applying `s` if this is a `Success`.

    Completes this `Try` by applying the function `f` to this if this is of type `Failure`, or conversely, by applying `s` if this is a `Success`.

    Definition Classes
      Success → Try
40.  val value: T
41.  final def wait(): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait--.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

42.  final def wait(arg0: Long, arg1: Int): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-int-

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
    Note

      not specified by SLS as a member of AnyRef

43.  final def wait(arg0: Long): Unit

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    See https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html#wait-long-.

    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
    Note

      not specified by SLS as a member of AnyRef

44.  final def withFilter(p: (T) => Boolean): WithFilter

    Creates a non-strict filter, which eventually converts this to a `Failure` if the predicate is not satisfied.

    Creates a non-strict filter, which eventually converts this to a `Failure` if the predicate is not satisfied.

    Note: unlike filter, withFilter does not create a new Try. Instead, it restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

    As Try is a one-element collection, this may be a bit overkill, but it's consistent with withFilter on Option and the other collections.

    p

      the predicate used to test elements.

    returns

      an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this Try which satisfy the predicate `p`.

    Definition Classes
      Try
    Annotations
      @inline()

### Deprecated Value Members

1.  def →[B](y: B): (Success[T], B)
   Implicit
     This member is added by an implicit conversion from Success[T] toArrowAssoc[Success[T]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from Try[T]

### Inherited from java.io.Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromSuccess[T] to any2stringadd[Success[T]]

### Inherited by implicit conversion StringFormat fromSuccess[T] to StringFormat[Success[T]]

### Inherited by implicit conversion Ensuring fromSuccess[T] to Ensuring[Success[T]]

### Inherited by implicit conversion ArrowAssoc fromSuccess[T] to ArrowAssoc[Success[T]]

### Ungrouped